Index: branches/SHM-dev/source/App/TAppEncoder/TAppEncTop.cpp
===================================================================
--- branches/SHM-dev/source/App/TAppEncoder/TAppEncTop.cpp	(revision 1376)
+++ branches/SHM-dev/source/App/TAppEncoder/TAppEncTop.cpp	(revision 1377)
@@ -393,412 +339,153 @@
     {
       assert( layer == 0 );
-      m_acTEncTop[layer].setNumDirectRefLayers(0);
-    }
-
-    //===== Slice ========
-
-    //====== Loop/Deblock Filter ========
-    m_acTEncTop[layer].setLoopFilterDisable                                ( m_bLoopFilterDisable       );
-    m_acTEncTop[layer].setLoopFilterOffsetInPPS                            ( m_loopFilterOffsetInPPS );
-    m_acTEncTop[layer].setLoopFilterBetaOffset                             ( m_loopFilterBetaOffsetDiv2  );
-    m_acTEncTop[layer].setLoopFilterTcOffset                               ( m_loopFilterTcOffsetDiv2    );    
-    m_acTEncTop[layer].setDeblockingFilterMetric                           ( m_DeblockingFilterMetric );
-
-    //====== Motion search ========
-    m_acTEncTop[layer].setDisableIntraPUsInInterSlices                     ( m_bDisableIntraPUsInInterSlices );
-    m_acTEncTop[layer].setFastSearch                                       ( m_iFastSearch  );
-    m_acTEncTop[layer].setSearchRange                                      ( m_iSearchRange );
-    m_acTEncTop[layer].setBipredSearchRange                                ( m_bipredSearchRange );
-    m_acTEncTop[layer].setClipForBiPredMeEnabled                           ( m_bClipForBiPredMeEnabled );
-    m_acTEncTop[layer].setFastMEAssumingSmootherMVEnabled                  ( m_bFastMEAssumingSmootherMVEnabled );
-
-    //====== Quality control ========
-    m_acTEncTop[layer].setMaxDeltaQP                                       ( m_iMaxDeltaQP  );
-    m_acTEncTop[layer].setMaxCuDQPDepth                                    ( m_acLayerCfg[layer].m_iMaxCuDQPDepth  );
-    m_acTEncTop[layer].setDiffCuChromaQpOffsetDepth                        ( m_diffCuChromaQpOffsetDepth );
-    m_acTEncTop[layer].setChromaCbQpOffset                                 ( m_cbQpOffset     );
-    m_acTEncTop[layer].setChromaCrQpOffset                                 ( m_crQpOffset  );
-
-    m_acTEncTop[layer].setChromaFormatIdc                                  ( m_acLayerCfg[layer].m_chromaFormatIDC  );
-
-#if ADAPTIVE_QP_SELECTION
-    m_acTEncTop[layer].setUseAdaptQpSelect                                 ( m_bUseAdaptQpSelect   );
-#endif
-    
-    m_acTEncTop[layer].setUseAdaptiveQP                                    ( m_bUseAdaptiveQP  );
-    m_acTEncTop[layer].setQPAdaptationRange                                ( m_iQPAdaptationRange );
-    m_acTEncTop[layer].setExtendedPrecisionProcessingFlag                  ( m_acLayerCfg[layer].m_extendedPrecisionProcessingFlag );
-    m_acTEncTop[layer].setHighPrecisionOffsetsEnabledFlag                  ( m_acLayerCfg[layer].m_highPrecisionOffsetsEnabledFlag );
-
-    //====== Tool list ========    
-    m_acTEncTop[layer].setDeltaQpRD                                        ( m_uiDeltaQpRD  );
-    m_acTEncTop[layer].setFastDeltaQp                                      ( m_bFastDeltaQP  );
-    m_acTEncTop[layer].setUseASR                                           ( m_bUseASR      );
-    m_acTEncTop[layer].setUseHADME                                         ( m_bUseHADME    );    
-    m_acTEncTop[layer].setdQPs                                             ( m_acLayerCfg[layer].getdQPs() );
-    m_acTEncTop[layer].setUseRDOQ                                          ( m_useRDOQ     );
-    m_acTEncTop[layer].setUseRDOQTS                                        ( m_useRDOQTS   );
-#if T0196_SELECTIVE_RDOQ
-    m_acTEncTop[layer].setUseSelectiveRDOQ                                 ( m_useSelectiveRDOQ );
-#endif
-    m_acTEncTop[layer].setRDpenalty                                        ( m_rdPenalty );
-    m_acTEncTop[layer].setMaxCUWidth                                       ( m_acLayerCfg[layer].m_uiMaxCUWidth );
-    m_acTEncTop[layer].setMaxCUHeight                                      ( m_acLayerCfg[layer].m_uiMaxCUHeight );
-    m_acTEncTop[layer].setMaxTotalCUDepth                                  ( m_acLayerCfg[layer].m_uiMaxTotalCUDepth );
-    m_acTEncTop[layer].setLog2DiffMaxMinCodingBlockSize                    ( m_acLayerCfg[layer].m_uiLog2DiffMaxMinCodingBlockSize );
-
-    m_acTEncTop[layer].setQuadtreeTULog2MaxSize                            ( m_acLayerCfg[layer].m_uiQuadtreeTULog2MaxSize );
-    m_acTEncTop[layer].setQuadtreeTULog2MinSize                            ( m_acLayerCfg[layer].m_uiQuadtreeTULog2MinSize );
-    m_acTEncTop[layer].setQuadtreeTUMaxDepthInter                          ( m_acLayerCfg[layer].m_uiQuadtreeTUMaxDepthInter );
-    m_acTEncTop[layer].setQuadtreeTUMaxDepthIntra                          ( m_acLayerCfg[layer].m_uiQuadtreeTUMaxDepthIntra );
-
-    m_acTEncTop[layer].setUseFastEnc                                       ( m_bUseFastEnc  );
-    m_acTEncTop[layer].setUseEarlyCU                                       ( m_bUseEarlyCU  );
-    m_acTEncTop[layer].setUseFastDecisionForMerge                          ( m_useFastDecisionForMerge  );
-    m_acTEncTop[layer].setUseCbfFastMode                                   ( m_bUseCbfFastMode  );
-    m_acTEncTop[layer].setUseEarlySkipDetection                            ( m_useEarlySkipDetection );
-    m_acTEncTop[layer].setCrossComponentPredictionEnabledFlag              ( m_crossComponentPredictionEnabledFlag );
-    m_acTEncTop[layer].setUseReconBasedCrossCPredictionEstimate            ( m_reconBasedCrossCPredictionEstimate );
-    m_acTEncTop[layer].setLog2SaoOffsetScale                               ( CHANNEL_TYPE_LUMA  , m_log2SaoOffsetScale[CHANNEL_TYPE_LUMA]   );
-    m_acTEncTop[layer].setLog2SaoOffsetScale                               ( CHANNEL_TYPE_CHROMA, m_log2SaoOffsetScale[CHANNEL_TYPE_CHROMA] );
-    m_acTEncTop[layer].setUseTransformSkip                                 ( m_useTransformSkip      );
-    m_acTEncTop[layer].setUseTransformSkipFast                             ( m_useTransformSkipFast  );
-    m_acTEncTop[layer].setTransformSkipRotationEnabledFlag                 ( m_transformSkipRotationEnabledFlag   );
-    m_acTEncTop[layer].setTransformSkipContextEnabledFlag                  ( m_transformSkipContextEnabledFlag   );
-    m_acTEncTop[layer].setPersistentRiceAdaptationEnabledFlag              ( m_persistentRiceAdaptationEnabledFlag );
-    m_acTEncTop[layer].setCabacBypassAlignmentEnabledFlag                  ( m_cabacBypassAlignmentEnabledFlag );
-    m_acTEncTop[layer].setLog2MaxTransformSkipBlockSize                    ( m_log2MaxTransformSkipBlockSize  );
-    for (UInt signallingModeIndex = 0; signallingModeIndex < NUMBER_OF_RDPCM_SIGNALLING_MODES; signallingModeIndex++)
-    {
-      m_acTEncTop[layer].setRdpcmEnabledFlag                               ( RDPCMSignallingMode(signallingModeIndex), m_rdpcmEnabledFlag[signallingModeIndex]);
-    }
-    m_acTEncTop[layer].setUseConstrainedIntraPred                          ( m_bUseConstrainedIntraPred );
-    m_acTEncTop[layer].setFastUDIUseMPMEnabled                             ( m_bFastUDIUseMPMEnabled );
-    m_acTEncTop[layer].setFastMEForGenBLowDelayEnabled                     ( m_bFastMEForGenBLowDelayEnabled );
-    m_acTEncTop[layer].setUseBLambdaForNonKeyLowDelayPictures              ( m_bUseBLambdaForNonKeyLowDelayPictures );
-    m_acTEncTop[layer].setPCMLog2MinSize                                   ( m_uiPCMLog2MinSize);
-    m_acTEncTop[layer].setUsePCM                                           ( m_usePCM );
-
-    for( UInt channelType = 0; channelType < MAX_NUM_CHANNEL_TYPE; channelType++ )
-    {
-      m_acTEncTop[layer].setBitDepth                                       ((ChannelType)channelType, m_acLayerCfg[layer].m_internalBitDepth[channelType]);
-      m_acTEncTop[layer].setPCMBitDepth                                    ((ChannelType)channelType, m_bPCMInputBitDepthFlag ? m_acLayerCfg[layer].m_MSBExtendedBitDepth[channelType] : m_acLayerCfg[layer].m_internalBitDepth[channelType]);
-    }
-    m_acTEncTop[layer].setPCMLog2MaxSize                                   ( m_pcmLog2MaxSize);
-    m_acTEncTop[layer].setMaxNumMergeCand                                  ( m_maxNumMergeCand );
-
-
-    //====== Weighted Prediction ========
-    m_acTEncTop[layer].setUseWP                                            ( m_useWeightedPred      );
-    m_acTEncTop[layer].setWPBiPred                                         ( m_useWeightedBiPred   );
-#if FAST_INTRA_SHVC
-    m_acTEncTop[layer].setUseFastIntraScalable                             ( m_useFastIntraScalable );
-#endif
-
-    if( layer != 0 && m_useInterLayerWeightedPred )
-    {
-      // Enable weighted prediction for enhancement layer
-      m_acTEncTop[layer].setUseWP                                           ( true   );
-      m_acTEncTop[layer].setWPBiPred                                        ( true   );
-    }
-
-    //====== Parallel Merge Estimation ========
-    m_acTEncTop[layer].setLog2ParallelMergeLevelMinus2                      ( m_log2ParallelMergeLevel - 2 );
-
-    //====== Slice ========
-    m_acTEncTop[layer].setSliceMode                                         ( (SliceConstraint) m_sliceMode );
-    m_acTEncTop[layer].setSliceArgument                                     ( m_sliceArgument            );
-
-    //====== Dependent Slice ========
-    m_acTEncTop[layer].setSliceSegmentMode                                  ( (SliceConstraint) m_sliceSegmentMode );
-    m_acTEncTop[layer].setSliceSegmentArgument                              ( m_sliceSegmentArgument     );
-
-    if(m_sliceMode == NO_SLICES )
-    {
-      m_bLFCrossSliceBoundaryFlag = true;
-    }
-
-    m_acTEncTop[layer].setLFCrossSliceBoundaryFlag                          ( m_bLFCrossSliceBoundaryFlag );
-    m_acTEncTop[layer].setUseSAO                                            ( m_bUseSAO );
-    m_acTEncTop[layer].setTestSAODisableAtPictureLevel                      ( m_bTestSAODisableAtPictureLevel );
-    m_acTEncTop[layer].setSaoEncodingRate                                   ( m_saoEncodingRate );
-    m_acTEncTop[layer].setSaoEncodingRateChroma                             ( m_saoEncodingRateChroma );
-    m_acTEncTop[layer].setMaxNumOffsetsPerPic                               ( m_maxNumOffsetsPerPic );
-
-    m_acTEncTop[layer].setSaoCtuBoundary                                    ( m_saoCtuBoundary );
-    m_acTEncTop[layer].setPCMInputBitDepthFlag                              ( m_bPCMInputBitDepthFlag);
-    m_acTEncTop[layer].setPCMFilterDisableFlag                              ( m_bPCMFilterDisableFlag);
-
-    m_acTEncTop[layer].setIntraSmoothingDisabledFlag                        (!m_enableIntraReferenceSmoothing );
-    m_acTEncTop[layer].setDecodedPictureHashSEIEnabled                      ( m_decodedPictureHashSEIEnabled );
-    m_acTEncTop[layer].setRecoveryPointSEIEnabled                           ( m_recoveryPointSEIEnabled );
-    m_acTEncTop[layer].setBufferingPeriodSEIEnabled                         ( m_bufferingPeriodSEIEnabled );
-    m_acTEncTop[layer].setPictureTimingSEIEnabled                           ( m_pictureTimingSEIEnabled );
-    m_acTEncTop[layer].setToneMappingInfoSEIEnabled                         ( m_toneMappingInfoSEIEnabled );
-    m_acTEncTop[layer].setTMISEIToneMapId                                   ( m_toneMapId );
-    m_acTEncTop[layer].setTMISEIToneMapCancelFlag                           ( m_toneMapCancelFlag );
-    m_acTEncTop[layer].setTMISEIToneMapPersistenceFlag                      ( m_toneMapPersistenceFlag );
-    m_acTEncTop[layer].setTMISEICodedDataBitDepth                           ( m_toneMapCodedDataBitDepth );
-    m_acTEncTop[layer].setTMISEITargetBitDepth                              ( m_toneMapTargetBitDepth );
-    m_acTEncTop[layer].setTMISEIModelID                                     ( m_toneMapModelId );
-    m_acTEncTop[layer].setTMISEIMinValue                                    ( m_toneMapMinValue );
-    m_acTEncTop[layer].setTMISEIMaxValue                                    ( m_toneMapMaxValue );
-    m_acTEncTop[layer].setTMISEISigmoidMidpoint                             ( m_sigmoidMidpoint );
-    m_acTEncTop[layer].setTMISEISigmoidWidth                                ( m_sigmoidWidth );
-    m_acTEncTop[layer].setTMISEIStartOfCodedInterva                         ( m_startOfCodedInterval );
-    m_acTEncTop[layer].setTMISEINumPivots                                   ( m_numPivots );
-    m_acTEncTop[layer].setTMISEICodedPivotValue                             ( m_codedPivotValue );
-    m_acTEncTop[layer].setTMISEITargetPivotValue                            ( m_targetPivotValue );
-    m_acTEncTop[layer].setTMISEICameraIsoSpeedIdc                           ( m_cameraIsoSpeedIdc );
-    m_acTEncTop[layer].setTMISEICameraIsoSpeedValue                         ( m_cameraIsoSpeedValue );
-    m_acTEncTop[layer].setTMISEIExposureIndexIdc                            ( m_exposureIndexIdc );
-    m_acTEncTop[layer].setTMISEIExposureIndexValue                          ( m_exposureIndexValue );
-    m_acTEncTop[layer].setTMISEIExposureCompensationValueSignFlag           ( m_exposureCompensationValueSignFlag );
-    m_acTEncTop[layer].setTMISEIExposureCompensationValueNumerator          ( m_exposureCompensationValueNumerator );
-    m_acTEncTop[layer].setTMISEIExposureCompensationValueDenomIdc           ( m_exposureCompensationValueDenomIdc );
-    m_acTEncTop[layer].setTMISEIRefScreenLuminanceWhite                     ( m_refScreenLuminanceWhite );
-    m_acTEncTop[layer].setTMISEIExtendedRangeWhiteLevel                     ( m_extendedRangeWhiteLevel );
-    m_acTEncTop[layer].setTMISEINominalBlackLevelLumaCodeValue              ( m_nominalBlackLevelLumaCodeValue );
-    m_acTEncTop[layer].setTMISEINominalWhiteLevelLumaCodeValue              ( m_nominalWhiteLevelLumaCodeValue );
-    m_acTEncTop[layer].setTMISEIExtendedWhiteLevelLumaCodeValue             ( m_extendedWhiteLevelLumaCodeValue );
-    m_acTEncTop[layer].setChromaSamplingFilterHintEnabled                   ( m_chromaSamplingFilterSEIenabled );
-    m_acTEncTop[layer].setChromaSamplingHorFilterIdc                        ( m_chromaSamplingHorFilterIdc );
-    m_acTEncTop[layer].setChromaSamplingVerFilterIdc                        ( m_chromaSamplingVerFilterIdc );
-    m_acTEncTop[layer].setFramePackingArrangementSEIEnabled                 ( m_framePackingSEIEnabled );
-    m_acTEncTop[layer].setFramePackingArrangementSEIType                    ( m_framePackingSEIType );
-    m_acTEncTop[layer].setFramePackingArrangementSEIId                      ( m_framePackingSEIId );
-    m_acTEncTop[layer].setFramePackingArrangementSEIQuincunx                ( m_framePackingSEIQuincunx );
-    m_acTEncTop[layer].setFramePackingArrangementSEIInterpretation          ( m_framePackingSEIInterpretation );
-    m_acTEncTop[layer].setSegmentedRectFramePackingArrangementSEIEnabled    ( m_segmentedRectFramePackingSEIEnabled );
-    m_acTEncTop[layer].setSegmentedRectFramePackingArrangementSEICancel     ( m_segmentedRectFramePackingSEICancel );
-    m_acTEncTop[layer].setSegmentedRectFramePackingArrangementSEIType       ( m_segmentedRectFramePackingSEIType );
-    m_acTEncTop[layer].setSegmentedRectFramePackingArrangementSEIPersistence( m_segmentedRectFramePackingSEIPersistence );
-    m_acTEncTop[layer].setDisplayOrientationSEIAngle                        ( m_displayOrientationSEIAngle );
-    m_acTEncTop[layer].setTemporalLevel0IndexSEIEnabled                     ( m_temporalLevel0IndexSEIEnabled );
-    m_acTEncTop[layer].setGradualDecodingRefreshInfoEnabled                 ( m_gradualDecodingRefreshInfoEnabled );
-    m_acTEncTop[layer].setNoDisplaySEITLayer                                ( m_noDisplaySEITLayer );
-    m_acTEncTop[layer].setDecodingUnitInfoSEIEnabled                        ( m_decodingUnitInfoSEIEnabled );
-    m_acTEncTop[layer].setSOPDescriptionSEIEnabled                          ( m_SOPDescriptionSEIEnabled );
-    m_acTEncTop[layer].setScalableNestingSEIEnabled                         ( m_scalableNestingSEIEnabled );
-    m_acTEncTop[layer].setTMCTSSEIEnabled                                   ( m_tmctsSEIEnabled );
-    m_acTEncTop[layer].setTimeCodeSEIEnabled                                ( m_timeCodeSEIEnabled );
-    m_acTEncTop[layer].setNumberOfTimeSets                                  ( m_timeCodeSEINumTs );
-    for(Int i = 0; i < m_timeCodeSEINumTs; i++)
-    { 
-      m_acTEncTop[layer].setTimeSet(m_timeSetArray[i], i);
-    }
-    m_acTEncTop[layer].setKneeSEIEnabled                                    ( m_kneeSEIEnabled );
-    m_acTEncTop[layer].setKneeSEIId                                         ( m_kneeSEIId );
-    m_acTEncTop[layer].setKneeSEICancelFlag                                 ( m_kneeSEICancelFlag );
-    m_acTEncTop[layer].setKneeSEIPersistenceFlag                            ( m_kneeSEIPersistenceFlag );    
-    m_acTEncTop[layer].setKneeSEIInputDrange                                ( m_kneeSEIInputDrange );
-    m_acTEncTop[layer].setKneeSEIInputDispLuminance                         ( m_kneeSEIInputDispLuminance );
-    m_acTEncTop[layer].setKneeSEIOutputDrange                               ( m_kneeSEIOutputDrange );
-    m_acTEncTop[layer].setKneeSEIOutputDispLuminance                        ( m_kneeSEIOutputDispLuminance );
-    m_acTEncTop[layer].setKneeSEINumKneePointsMinus1                        ( m_kneeSEINumKneePointsMinus1 );
-    m_acTEncTop[layer].setKneeSEIInputKneePoint                             ( m_kneeSEIInputKneePoint );
-    m_acTEncTop[layer].setKneeSEIOutputKneePoint                            ( m_kneeSEIOutputKneePoint );
-    m_acTEncTop[layer].setMasteringDisplaySEI                               ( m_masteringDisplay );
-#if P0123_ALPHA_CHANNEL_SEI
-    m_acTEncTop[layer].setAlphaSEIEnabled                                   ( m_alphaSEIEnabled );
-    m_acTEncTop[layer].setAlphaCancelFlag                                   ( m_alphaCancelFlag );
-    m_acTEncTop[layer].setAlphaUseIdc                                       ( m_alphaUseIdc );
-    m_acTEncTop[layer].setAlphaBitDepthMinus8                               ( m_alphaBitDepthMinus8 );
-    m_acTEncTop[layer].setAlphaTransparentValue                             ( m_alphaTransparentValue );
-    m_acTEncTop[layer].setAlphaOpaqueValue                                  ( m_alphaOpaqueValue );
-    m_acTEncTop[layer].setAlphaIncrementFlag                                ( m_alphaIncrementFlag );
-    m_acTEncTop[layer].setAlphaClipFlag                                     ( m_alphaClipFlag );
-    m_acTEncTop[layer].setAlphaClipTypeFlag                                 ( m_alphaClipTypeFlag );
-#endif
-#if Q0096_OVERLAY_SEI
-    m_acTEncTop[layer].setOverlaySEIEnabled                                 ( m_overlaySEIEnabled );
-    m_acTEncTop[layer].setOverlaySEICancelFlag                              ( m_overlayInfoCancelFlag );
-    m_acTEncTop[layer].setOverlaySEIContentAuxIdMinus128                    ( m_overlayContentAuxIdMinus128 );
-    m_acTEncTop[layer].setOverlaySEILabelAuxIdMinus128                      ( m_overlayLabelAuxIdMinus128 );
-    m_acTEncTop[layer].setOverlaySEIAlphaAuxIdMinus128                      ( m_overlayAlphaAuxIdMinus128 );
-    m_acTEncTop[layer].setOverlaySEIElementLabelValueLengthMinus8           ( m_overlayElementLabelValueLengthMinus8 );
-    m_acTEncTop[layer].setOverlaySEINumOverlaysMinus1                       ( m_numOverlaysMinus1 );
-    m_acTEncTop[layer].setOverlaySEIIdx                                     ( m_overlayIdx );
-    m_acTEncTop[layer].setOverlaySEILanguagePresentFlag                     ( m_overlayLanguagePresentFlag );
-    m_acTEncTop[layer].setOverlaySEIContentLayerId                          ( m_overlayContentLayerId );
-    m_acTEncTop[layer].setOverlaySEILabelPresentFlag                        ( m_overlayLabelPresentFlag );
-    m_acTEncTop[layer].setOverlaySEILabelLayerId                            ( m_overlayLabelLayerId );
-    m_acTEncTop[layer].setOverlaySEIAlphaPresentFlag                        ( m_overlayAlphaPresentFlag );
-    m_acTEncTop[layer].setOverlaySEIAlphaLayerId                            ( m_overlayAlphaLayerId );
-    m_acTEncTop[layer].setOverlaySEINumElementsMinus1                       ( m_numOverlayElementsMinus1 );
-    m_acTEncTop[layer].setOverlaySEIElementLabelMin                         ( m_overlayElementLabelMin );
-    m_acTEncTop[layer].setOverlaySEIElementLabelMax                         ( m_overlayElementLabelMax );
-    m_acTEncTop[layer].setOverlaySEILanguage                                ( m_overlayLanguage );
-    m_acTEncTop[layer].setOverlaySEIName                                    ( m_overlayName );
-    m_acTEncTop[layer].setOverlaySEIElementName                             ( m_overlayElementName );
-    m_acTEncTop[layer].setOverlaySEIPersistenceFlag                         ( m_overlayInfoPersistenceFlag );
-#endif
-#if Q0074_COLOUR_REMAPPING_SEI
-    m_acTEncTop[layer].setCRISEIFileRoot                                    ( const_cast<Char*>(m_acLayerCfg[layer].m_colourRemapSEIFileRoot.c_str()) );
-#endif    
-#if LAYERS_NOT_PRESENT_SEI
-    m_acTEncTop[layer].setLayersNotPresentSEIEnabled            ( m_layersNotPresentSEIEnabled );
-#endif    
-#if Q0189_TMVP_CONSTRAINTS
-    m_acTEncTop[layer].setTMVPConstraintsSEIEnabled             ( m_TMVPConstraintsSEIEnabled);           
-#endif
-#if N0383_IL_CONSTRAINED_TILE_SETS_SEI
-    m_acTEncTop[layer].setInterLayerConstrainedTileSetsSEIEnabled( m_interLayerConstrainedTileSetsSEIEnabled );
-    m_acTEncTop[layer].setIlNumSetsInMessage                    ( m_ilNumSetsInMessage );
-    m_acTEncTop[layer].setSkippedTileSetPresentFlag             ( m_skippedTileSetPresentFlag );
-    m_acTEncTop[layer].setTopLeftTileIndex                      ( m_topLeftTileIndex );
-    m_acTEncTop[layer].setBottomRightTileIndex                  ( m_bottomRightTileIndex );
-    m_acTEncTop[layer].setIlcIdc                                ( m_ilcIdc );
-#endif
-    m_acTEncTop[layer].setTileUniformSpacingFlag                ( m_tileUniformSpacingFlag );
-    m_acTEncTop[layer].setNumColumnsMinus1                      ( m_numTileColumnsMinus1 );
-    m_acTEncTop[layer].setNumRowsMinus1                         ( m_numTileRowsMinus1 );
-    if(!m_tileUniformSpacingFlag)
-    {
-      m_acTEncTop[layer].setColumnWidth                         ( m_tileColumnWidth );
-      m_acTEncTop[layer].setRowHeight                           ( m_tileRowHeight );
-    }
-    m_acTEncTop[layer].xCheckGSParameters();
-    Int uiTilesCount = (m_numTileRowsMinus1+1) * (m_numTileColumnsMinus1+1);
-    if(uiTilesCount == 1)
-    {
-      m_bLFCrossTileBoundaryFlag = true;
-    }
-    m_acTEncTop[layer].setLFCrossTileBoundaryFlag               ( m_bLFCrossTileBoundaryFlag );
-    m_acTEncTop[layer].setWaveFrontSynchro                      ( m_acLayerCfg[layer].m_waveFrontSynchro );
-    m_acTEncTop[layer].setTMVPModeId                            ( m_TMVPModeId );
-    m_acTEncTop[layer].setUseScalingListId                      ( m_useScalingListId  );
-    m_acTEncTop[layer].setScalingListFile                       ( m_scalingListFile   );
-    m_acTEncTop[layer].setSignHideFlag                          ( m_signHideFlag );
-#if RC_SHVC_HARMONIZATION
-    m_acTEncTop[layer].setUseRateCtrl                           ( m_acLayerCfg[layer].getRCEnableRateControl() );
-    m_acTEncTop[layer].setTargetBitrate                         ( m_acLayerCfg[layer].getRCTargetBitrate() );
-    m_acTEncTop[layer].setKeepHierBit                           ( m_acLayerCfg[layer].getRCKeepHierarchicalBit() );
-    m_acTEncTop[layer].setLCULevelRC                            ( m_acLayerCfg[layer].getRCLCULevelRC() );
-    m_acTEncTop[layer].setUseLCUSeparateModel                   ( m_acLayerCfg[layer].getRCUseLCUSeparateModel() );
-    m_acTEncTop[layer].setInitialQP                             ( m_acLayerCfg[layer].getRCInitialQP() );
-    m_acTEncTop[layer].setForceIntraQP                          ( m_acLayerCfg[layer].getRCForceIntraQP() );
-#else
-    m_acTEncTop[layer].setUseRateCtrl                           ( m_RCEnableRateControl );
-    m_acTEncTop[layer].setTargetBitrate                         ( m_RCTargetBitrate );
-    m_acTEncTop[layer].setKeepHierBit                           ( m_RCKeepHierarchicalBit );
-    m_acTEncTop[layer].setLCULevelRC                            ( m_RCLCULevelRC );
-    m_acTEncTop[layer].setUseLCUSeparateModel                   ( m_RCUseLCUSeparateModel );
-    m_acTEncTop[layer].setInitialQP                             ( m_RCInitialQP );
-    m_acTEncTop[layer].setForceIntraQP                          ( m_RCForceIntraQP );
-#endif
-    m_acTEncTop[layer].setTransquantBypassEnableFlag            ( m_TransquantBypassEnableFlag );
-    m_acTEncTop[layer].setCUTransquantBypassFlagForceValue      ( m_CUTransquantBypassFlagForce );
-    m_acTEncTop[layer].setCostMode                              ( m_costMode );
-    m_acTEncTop[layer].setUseRecalculateQPAccordingToLambda     ( m_recalculateQPAccordingToLambda );
-    m_acTEncTop[layer].setUseStrongIntraSmoothing               ( m_useStrongIntraSmoothing );
-    m_acTEncTop[layer].setActiveParameterSetsSEIEnabled         ( m_activeParameterSetsSEIEnabled );
-    m_acTEncTop[layer].setVuiParametersPresentFlag              ( m_vuiParametersPresentFlag );
-    m_acTEncTop[layer].setAspectRatioInfoPresentFlag            ( m_aspectRatioInfoPresentFlag);
-    m_acTEncTop[layer].setAspectRatioIdc                        ( m_aspectRatioIdc );
-    m_acTEncTop[layer].setSarWidth                              ( m_sarWidth );
-    m_acTEncTop[layer].setSarHeight                             ( m_sarHeight );
-    m_acTEncTop[layer].setOverscanInfoPresentFlag               ( m_overscanInfoPresentFlag );
-    m_acTEncTop[layer].setOverscanAppropriateFlag               ( m_overscanAppropriateFlag );
-    m_acTEncTop[layer].setVideoSignalTypePresentFlag            ( m_videoSignalTypePresentFlag );
-    m_acTEncTop[layer].setVideoFormat                           ( m_videoFormat );
-    m_acTEncTop[layer].setVideoFullRangeFlag                    ( m_videoFullRangeFlag );
-    m_acTEncTop[layer].setColourDescriptionPresentFlag          ( m_colourDescriptionPresentFlag );
-    m_acTEncTop[layer].setColourPrimaries                       ( m_colourPrimaries );
-    m_acTEncTop[layer].setTransferCharacteristics               ( m_transferCharacteristics );
-    m_acTEncTop[layer].setMatrixCoefficients                    ( m_matrixCoefficients );
-    m_acTEncTop[layer].setChromaLocInfoPresentFlag              ( m_chromaLocInfoPresentFlag );
-    m_acTEncTop[layer].setChromaSampleLocTypeTopField           ( m_chromaSampleLocTypeTopField );
-    m_acTEncTop[layer].setChromaSampleLocTypeBottomField        ( m_chromaSampleLocTypeBottomField );
-    m_acTEncTop[layer].setNeutralChromaIndicationFlag           ( m_neutralChromaIndicationFlag );
-    m_acTEncTop[layer].setDefaultDisplayWindow                  ( m_defDispWinLeftOffset, m_defDispWinRightOffset, m_defDispWinTopOffset, m_defDispWinBottomOffset );
-    m_acTEncTop[layer].setFrameFieldInfoPresentFlag             ( m_frameFieldInfoPresentFlag );
-    m_acTEncTop[layer].setPocProportionalToTimingFlag           ( m_pocProportionalToTimingFlag );
-    m_acTEncTop[layer].setNumTicksPocDiffOneMinus1              ( m_numTicksPocDiffOneMinus1    );
-    m_acTEncTop[layer].setBitstreamRestrictionFlag              ( m_bitstreamRestrictionFlag );
-    m_acTEncTop[layer].setTilesFixedStructureFlag               ( m_tilesFixedStructureFlag );
-    m_acTEncTop[layer].setMotionVectorsOverPicBoundariesFlag    ( m_motionVectorsOverPicBoundariesFlag );
-    m_acTEncTop[layer].setMinSpatialSegmentationIdc             ( m_minSpatialSegmentationIdc );
-    m_acTEncTop[layer].setMaxBytesPerPicDenom                   ( m_maxBytesPerPicDenom );
-    m_acTEncTop[layer].setMaxBitsPerMinCuDenom                  ( m_maxBitsPerMinCuDenom );
-    m_acTEncTop[layer].setLog2MaxMvLengthHorizontal             ( m_log2MaxMvLengthHorizontal );
-    m_acTEncTop[layer].setLog2MaxMvLengthVertical               ( m_log2MaxMvLengthVertical );
-    m_acTEncTop[layer].setElRapSliceTypeB                       (layer == 0? 0 : m_elRapSliceBEnabled);
-    m_acTEncTop[layer].setEfficientFieldIRAPEnabled             ( m_bEfficientFieldIRAPEnabled );
-    m_acTEncTop[layer].setHarmonizeGopFirstFieldCoupleEnabled   ( m_bHarmonizeGopFirstFieldCoupleEnabled );
-
-    m_acTEncTop[layer].setSummaryOutFilename                    ( m_summaryOutFilename );
-    m_acTEncTop[layer].setSummaryPicFilenameBase                ( m_summaryPicFilenameBase );
-    m_acTEncTop[layer].setSummaryVerboseness                    ( m_summaryVerboseness );
+      m_cTEncTop.setNumDirectRefLayers(0);
+    }
 
     if( layer > 0 )
     {
 #if AUXILIARY_PICTURES
-      Int subWidthC  = ( m_acLayerCfg[layer].m_chromaFormatIDC == CHROMA_420 || m_acLayerCfg[layer].m_chromaFormatIDC == CHROMA_422 ) ? 2 : 1;
-      Int subHeightC = ( m_acLayerCfg[layer].m_chromaFormatIDC == CHROMA_420 ) ? 2 : 1;
+      Int subWidthC  = ( m_apcLayerCfg[layer]->m_chromaFormatIDC == CHROMA_420 || m_apcLayerCfg[layer]->m_chromaFormatIDC == CHROMA_422 ) ? 2 : 1;
+      Int subHeightC = ( m_apcLayerCfg[layer]->m_chromaFormatIDC == CHROMA_420 ) ? 2 : 1;
 #else
       Int subWidthC  = 2;
       Int subHeightC = 2;
 #endif
-      m_acTEncTop[layer].setNumRefLayerLocationOffsets          ( m_acLayerCfg[layer].m_numRefLayerLocationOffsets );
-      for(Int i = 0; i < m_acLayerCfg[layer].m_numRefLayerLocationOffsets; i++)
-      {
-        m_acTEncTop[layer].setRefLocationOffsetLayerId          (i, m_acLayerCfg[layer].m_refLocationOffsetLayerId[i]);
-        m_acTEncTop[layer].setScaledRefLayerOffsetPresentFlag   ( i, m_acLayerCfg[layer].m_scaledRefLayerOffsetPresentFlag[i] );
-        m_acTEncTop[layer].getScaledRefLayerWindow(i).setWindow ( subWidthC  * m_acLayerCfg[layer].m_scaledRefLayerLeftOffset[i], subWidthC  * m_acLayerCfg[layer].m_scaledRefLayerRightOffset[i],
-                                                                  subHeightC * m_acLayerCfg[layer].m_scaledRefLayerTopOffset[i],  subHeightC * m_acLayerCfg[layer].m_scaledRefLayerBottomOffset[i]);
-
-        Int rlSubWidthC  = ( m_acLayerCfg[i].m_chromaFormatIDC == CHROMA_420 || m_acLayerCfg[i].m_chromaFormatIDC == CHROMA_422 ) ? 2 : 1;
-        Int rlSubHeightC = ( m_acLayerCfg[i].m_chromaFormatIDC == CHROMA_420 ) ? 2 : 1;
-
-        m_acTEncTop[layer].setRefRegionOffsetPresentFlag        ( i, m_acLayerCfg[layer].m_refRegionOffsetPresentFlag[i] );
-        m_acTEncTop[layer].getRefLayerWindow(i).setWindow       ( rlSubWidthC  * m_acLayerCfg[layer].m_refRegionLeftOffset[i], rlSubWidthC  * m_acLayerCfg[layer].m_refRegionRightOffset[i],
-                                                                  rlSubHeightC * m_acLayerCfg[layer].m_refRegionTopOffset[i],  rlSubHeightC * m_acLayerCfg[layer].m_refRegionBottomOffset[i]);
-        m_acTEncTop[layer].setResamplePhaseSetPresentFlag       ( i, m_acLayerCfg[layer].m_resamplePhaseSetPresentFlag[i] );
-        m_acTEncTop[layer].setPhaseHorLuma                      ( i, m_acLayerCfg[layer].m_phaseHorLuma[i] );
-        m_acTEncTop[layer].setPhaseVerLuma                      ( i, m_acLayerCfg[layer].m_phaseVerLuma[i] );
-        m_acTEncTop[layer].setPhaseHorChroma                    ( i, m_acLayerCfg[layer].m_phaseHorChroma[i] );
-        m_acTEncTop[layer].setPhaseVerChroma                    ( i, m_acLayerCfg[layer].m_phaseVerChroma[i] );
-      }
-    }
-
-    m_acTEncTop[layer].setAdaptiveResolutionChange               ( m_adaptiveResolutionChange );
-    m_acTEncTop[layer].setLayerSwitchOffBegin                    ( m_acLayerCfg[layer].m_layerSwitchOffBegin );
-    m_acTEncTop[layer].setLayerSwitchOffEnd                      ( m_acLayerCfg[layer].m_layerSwitchOffEnd );
-#if AUXILIARY_PICTURES
-    m_acTEncTop[layer].setChromaFormatIDC                        ( m_acLayerCfg[layer].m_chromaFormatIDC );
-#endif
-    m_acTEncTop[layer].setAltOuputLayerFlag                      ( m_altOutputLayerFlag );
-    m_acTEncTop[layer].setCrossLayerBLAFlag                      ( m_crossLayerBLAFlag );
+      m_cTEncTop.setNumRefLayerLocationOffsets          ( m_apcLayerCfg[layer]->m_numRefLayerLocationOffsets );
+      for(Int i = 0; i < m_apcLayerCfg[layer]->m_numRefLayerLocationOffsets; i++)
+      {
+        m_cTEncTop.setRefLocationOffsetLayerId          ( i, m_apcLayerCfg[layer]->m_refLocationOffsetLayerId[i]);
+        m_cTEncTop.setScaledRefLayerOffsetPresentFlag   ( i, m_apcLayerCfg[layer]->m_scaledRefLayerOffsetPresentFlag[i] );
+        m_cTEncTop.getScaledRefLayerWindow(i).setWindow ( subWidthC  * m_apcLayerCfg[layer]->m_scaledRefLayerLeftOffset[i], subWidthC  * m_apcLayerCfg[layer]->m_scaledRefLayerRightOffset[i],
+          subHeightC * m_apcLayerCfg[layer]->m_scaledRefLayerTopOffset[i],  subHeightC * m_apcLayerCfg[layer]->m_scaledRefLayerBottomOffset[i]);
+
+        Int rlSubWidthC  = ( m_apcLayerCfg[i]->m_chromaFormatIDC == CHROMA_420 || m_apcLayerCfg[i]->m_chromaFormatIDC == CHROMA_422 ) ? 2 : 1;
+        Int rlSubHeightC = ( m_apcLayerCfg[i]->m_chromaFormatIDC == CHROMA_420 ) ? 2 : 1;
+
+        m_cTEncTop.setRefRegionOffsetPresentFlag        ( i, m_apcLayerCfg[layer]->m_refRegionOffsetPresentFlag[i] );
+        m_cTEncTop.getRefLayerWindow(i).setWindow       ( rlSubWidthC  * m_apcLayerCfg[layer]->m_refRegionLeftOffset[i], rlSubWidthC  * m_apcLayerCfg[layer]->m_refRegionRightOffset[i],
+          rlSubHeightC * m_apcLayerCfg[layer]->m_refRegionTopOffset[i],  rlSubHeightC * m_apcLayerCfg[layer]->m_refRegionBottomOffset[i]);
+        m_cTEncTop.setResamplePhaseSetPresentFlag       ( i, m_apcLayerCfg[layer]->m_resamplePhaseSetPresentFlag[i] );
+        m_cTEncTop.setPhaseHorLuma                      ( i, m_apcLayerCfg[layer]->m_phaseHorLuma[i] );
+        m_cTEncTop.setPhaseVerLuma                      ( i, m_apcLayerCfg[layer]->m_phaseVerLuma[i] );
+        m_cTEncTop.setPhaseHorChroma                    ( i, m_apcLayerCfg[layer]->m_phaseHorChroma[i] );
+        m_cTEncTop.setPhaseVerChroma                    ( i, m_apcLayerCfg[layer]->m_phaseVerChroma[i] );
+      }
+    }
+
+    m_cTEncTop.setAdaptiveResolutionChange               ( m_adaptiveResolutionChange );
+    m_cTEncTop.setLayerSwitchOffBegin                    ( m_apcLayerCfg[layer]->m_layerSwitchOffBegin );
+    m_cTEncTop.setLayerSwitchOffEnd                      ( m_apcLayerCfg[layer]->m_layerSwitchOffEnd );
+    m_cTEncTop.setChromaFormatIDC                        ( m_apcLayerCfg[layer]->m_chromaFormatIDC );
+    m_cTEncTop.setAltOuputLayerFlag                      ( m_altOutputLayerFlag );
+    m_cTEncTop.setCrossLayerBLAFlag                      ( m_crossLayerBLAFlag );
 #if CGS_3D_ASYMLUT
-    m_acTEncTop[layer].setCGSFlag                                ( layer == 0 ? 0 : m_nCGSFlag );
-    m_acTEncTop[layer].setCGSMaxOctantDepth                      ( m_nCGSMaxOctantDepth );
-    m_acTEncTop[layer].setCGSMaxYPartNumLog2                     ( m_nCGSMaxYPartNumLog2 );
-    m_acTEncTop[layer].setCGSLUTBit                              ( m_nCGSLUTBit );
-    m_acTEncTop[layer].setCGSAdaptChroma                         ( m_nCGSAdaptiveChroma );
+    m_cTEncTop.setCGSFlag                                ( layer == 0 ? 0 : m_nCGSFlag );
+    m_cTEncTop.setCGSMaxOctantDepth                      ( m_nCGSMaxOctantDepth );
+    m_cTEncTop.setCGSMaxYPartNumLog2                     ( m_nCGSMaxYPartNumLog2 );
+    m_cTEncTop.setCGSLUTBit                              ( m_nCGSLUTBit );
+    m_cTEncTop.setCGSAdaptChroma                         ( m_nCGSAdaptiveChroma );
 #if R0179_ENC_OPT_3DLUT_SIZE
-    m_acTEncTop[layer].setCGSLutSizeRDO                          ( m_nCGSLutSizeRDO );
-#endif
-#endif
-    m_acTEncTop[layer].setNumAddLayerSets                        ( m_numAddLayerSets );
-  }
-}
-#else //SVC_EXTENSION
-Void TAppEncTop::xInitLibCfg()
-{
-  TComVPS vps;
-
-  vps.setMaxTLayers                                               ( m_maxTempLayer );
-  if (m_maxTempLayer == 1)
-  {
-    vps.setTemporalNestingFlag(true);
-  }
-  vps.setMaxLayers                                                ( 1 );
-  for(Int i = 0; i < MAX_TLAYER; i++)
-  {
-    vps.setNumReorderPics                                         ( m_numReorderPics[i], i );
-    vps.setMaxDecPicBuffering                                     ( m_maxDecPicBuffering[i], i );
-  }
-  m_cTEncTop.setVPS(&vps);
+    m_cTEncTop.setCGSLutSizeRDO                          ( m_nCGSLutSizeRDO );
+#endif
+#endif
+    m_cTEncTop.setNumAddLayerSets                        ( m_numAddLayerSets );
+
+#if P0123_ALPHA_CHANNEL_SEI
+    m_cTEncTop.setAlphaSEIEnabled                                   ( m_alphaSEIEnabled );
+    m_cTEncTop.setAlphaCancelFlag                                   ( m_alphaCancelFlag );
+    m_cTEncTop.setAlphaUseIdc                                       ( m_alphaUseIdc );
+    m_cTEncTop.setAlphaBitDepthMinus8                               ( m_alphaBitDepthMinus8 );
+    m_cTEncTop.setAlphaTransparentValue                             ( m_alphaTransparentValue );
+    m_cTEncTop.setAlphaOpaqueValue                                  ( m_alphaOpaqueValue );
+    m_cTEncTop.setAlphaIncrementFlag                                ( m_alphaIncrementFlag );
+    m_cTEncTop.setAlphaClipFlag                                     ( m_alphaClipFlag );
+    m_cTEncTop.setAlphaClipTypeFlag                                 ( m_alphaClipTypeFlag );
+#endif
+#if Q0096_OVERLAY_SEI
+    m_cTEncTop.setOverlaySEIEnabled                                 ( m_overlaySEIEnabled );
+    m_cTEncTop.setOverlaySEICancelFlag                              ( m_overlayInfoCancelFlag );
+    m_cTEncTop.setOverlaySEIContentAuxIdMinus128                    ( m_overlayContentAuxIdMinus128 );
+    m_cTEncTop.setOverlaySEILabelAuxIdMinus128                      ( m_overlayLabelAuxIdMinus128 );
+    m_cTEncTop.setOverlaySEIAlphaAuxIdMinus128                      ( m_overlayAlphaAuxIdMinus128 );
+    m_cTEncTop.setOverlaySEIElementLabelValueLengthMinus8           ( m_overlayElementLabelValueLengthMinus8 );
+    m_cTEncTop.setOverlaySEINumOverlaysMinus1                       ( m_numOverlaysMinus1 );
+    m_cTEncTop.setOverlaySEIIdx                                     ( m_overlayIdx );
+    m_cTEncTop.setOverlaySEILanguagePresentFlag                     ( m_overlayLanguagePresentFlag );
+    m_cTEncTop.setOverlaySEIContentLayerId                          ( m_overlayContentLayerId );
+    m_cTEncTop.setOverlaySEILabelPresentFlag                        ( m_overlayLabelPresentFlag );
+    m_cTEncTop.setOverlaySEILabelLayerId                            ( m_overlayLabelLayerId );
+    m_cTEncTop.setOverlaySEIAlphaPresentFlag                        ( m_overlayAlphaPresentFlag );
+    m_cTEncTop.setOverlaySEIAlphaLayerId                            ( m_overlayAlphaLayerId );
+    m_cTEncTop.setOverlaySEINumElementsMinus1                       ( m_numOverlayElementsMinus1 );
+    m_cTEncTop.setOverlaySEIElementLabelMin                         ( m_overlayElementLabelMin );
+    m_cTEncTop.setOverlaySEIElementLabelMax                         ( m_overlayElementLabelMax );
+    m_cTEncTop.setOverlaySEILanguage                                ( m_overlayLanguage );
+    m_cTEncTop.setOverlaySEIName                                    ( m_overlayName );
+    m_cTEncTop.setOverlaySEIElementName                             ( m_overlayElementName );
+    m_cTEncTop.setOverlaySEIPersistenceFlag                         ( m_overlayInfoPersistenceFlag );
+#endif  
+#if Q0189_TMVP_CONSTRAINTS
+    m_cTEncTop.setTMVPConstraintsSEIEnabled                         ( m_TMVPConstraintsSEIEnabled);           
+#endif
+#if N0383_IL_CONSTRAINED_TILE_SETS_SEI
+    m_cTEncTop.setInterLayerConstrainedTileSetsSEIEnabled           ( m_interLayerConstrainedTileSetsSEIEnabled );
+    m_cTEncTop.setIlNumSetsInMessage                                ( m_ilNumSetsInMessage );
+    m_cTEncTop.setSkippedTileSetPresentFlag                         ( m_skippedTileSetPresentFlag );
+    m_cTEncTop.setTopLeftTileIndex                                  ( m_topLeftTileIndex );
+    m_cTEncTop.setBottomRightTileIndex                              ( m_bottomRightTileIndex );
+    m_cTEncTop.setIlcIdc                                            ( m_ilcIdc );
+#endif
+
+    Int layerPTLIdx = m_apcLayerCfg[layer]->m_layerPTLIdx;
+
+    Profile::Name m_profile                                    = m_profileList[layerPTLIdx];
+    Level::Tier   m_levelTier                                  = m_levelTierList[layerPTLIdx];
+    Level::Name   m_level                                      = m_levelList[layerPTLIdx];
+    UInt          m_bitDepthConstraint                         = m_apcLayerCfg[layer]->m_bitDepthConstraint;
+    ChromaFormat  m_chromaFormatConstraint                     = m_apcLayerCfg[layer]->m_chromaFormatConstraint;
+    Bool          m_intraConstraintFlag                        = m_apcLayerCfg[layer]->m_intraConstraintFlag;
+    Bool          m_onePictureOnlyConstraintFlag               = m_apcLayerCfg[layer]->m_onePictureOnlyConstraintFlag;
+    Bool          m_lowerBitRateConstraintFlag                 = m_apcLayerCfg[layer]->m_lowerBitRateConstraintFlag;
+    Bool          m_progressiveSourceFlag                      = m_progressiveSourceFlagList[layerPTLIdx];
+    Bool          m_interlacedSourceFlag                       = m_interlacedSourceFlagList[layerPTLIdx];
+    Bool          m_nonPackedConstraintFlag                    = m_nonPackedConstraintFlagList[layerPTLIdx];
+    Bool          m_frameOnlyConstraintFlag                    = m_frameOnlyConstraintFlagList[layerPTLIdx];
+
+    Int           m_iFrameRate                                 = m_apcLayerCfg[layer]->getFrameRate();
+    Int           m_iSourceWidth                               = m_apcLayerCfg[layer]->getSourceWidth();
+    Int           m_iSourceHeight                              = m_apcLayerCfg[layer]->getSourceHeight();
+    Int           m_confWinLeft                                = m_apcLayerCfg[layer]->m_confWinLeft;
+    Int           m_confWinRight                               = m_apcLayerCfg[layer]->m_confWinRight;
+    Int           m_confWinTop                                 = m_apcLayerCfg[layer]->m_confWinTop;
+    Int           m_confWinBottom                              = m_apcLayerCfg[layer]->m_confWinBottom;
+
+    Int           m_iIntraPeriod                               = m_apcLayerCfg[layer]->m_iIntraPeriod;
+    Int           m_iQP                                        = m_apcLayerCfg[layer]->getIntQP();
+    Int          *m_aiPad                                      = m_apcLayerCfg[layer]->getPad();
+
+    Int           m_iMaxCuDQPDepth                             = m_apcLayerCfg[layer]->m_iMaxCuDQPDepth;
+    ChromaFormat  m_chromaFormatIDC                            = m_apcLayerCfg[layer]->m_chromaFormatIDC;
+    Bool          m_extendedPrecisionProcessingFlag            = m_apcLayerCfg[layer]->m_extendedPrecisionProcessingFlag;
+    Bool          m_highPrecisionOffsetsEnabledFlag            = m_apcLayerCfg[layer]->m_highPrecisionOffsetsEnabledFlag;
+    Int           *m_aidQP                                     = m_apcLayerCfg[layer]->getdQPs();
+
+    UInt          m_uiMaxCUWidth                               = m_apcLayerCfg[layer]->m_uiMaxCUWidth;
+    UInt          m_uiMaxCUHeight                              = m_apcLayerCfg[layer]->m_uiMaxCUHeight;
+    UInt          m_uiMaxTotalCUDepth                          = m_apcLayerCfg[layer]->m_uiMaxTotalCUDepth;
+    UInt          m_uiLog2DiffMaxMinCodingBlockSize            = m_apcLayerCfg[layer]->m_uiLog2DiffMaxMinCodingBlockSize;
+    UInt          m_uiQuadtreeTULog2MaxSize                    = m_apcLayerCfg[layer]->m_uiQuadtreeTULog2MaxSize;
+    UInt          m_uiQuadtreeTULog2MinSize                    = m_apcLayerCfg[layer]->m_uiQuadtreeTULog2MinSize;
+    UInt          m_uiQuadtreeTUMaxDepthInter                  = m_apcLayerCfg[layer]->m_uiQuadtreeTUMaxDepthInter;
+    UInt          m_uiQuadtreeTUMaxDepthIntra                  = m_apcLayerCfg[layer]->m_uiQuadtreeTUMaxDepthIntra;
+
+    Int           m_iWaveFrontSynchro                          = m_apcLayerCfg[layer]->m_waveFrontSynchro;
+    Bool          m_RCEnableRateControl                        = m_apcLayerCfg[layer]->getRCEnableRateControl();
+    Int           m_RCTargetBitrate                            = m_apcLayerCfg[layer]->getRCTargetBitrate();
+    Bool          m_RCKeepHierarchicalBit                      = m_apcLayerCfg[layer]->getRCKeepHierarchicalBit();
+    Bool          m_RCLCULevelRC                               = m_apcLayerCfg[layer]->getRCLCULevelRC();
+    Bool          m_RCUseLCUSeparateModel                      = m_apcLayerCfg[layer]->getRCUseLCUSeparateModel();
+    Int           m_RCInitialQP                                = m_apcLayerCfg[layer]->getRCInitialQP();
+    Bool          m_RCForceIntraQP                             = m_apcLayerCfg[layer]->getRCForceIntraQP();
+#endif
 
   m_cTEncTop.setProfile                                           ( m_profile);
